
/*
{ĳ͏iA̖ړIւ̓KANQ̕ۏ؂Ɍ肹AI܂َ͖IȔ@Ȃނ̕ۏ؂ȂÁû܂܁vŒ񋟂܂B
@ȂꍇA҂⒘쌠҂͖{ĳ₻̎gpɊ֘AĔA܂͂̎gpɋN̂łA_ᔽȂ̑Q₻̑̔̐ӔC͕܂B
*/

// longRes = intIn1~intIn2
#define MultiU16X16to32(longRes, intIn1, intIn2) \
asm volatile ( \
"CLR R26 \n\t" \
"MUL %A1, %A2 \n\t" \
"MOVW %A0, R0 \n\t" \
"MUL %B1, %B2 \n\t" \
"MOVW %C0, R0 \n\t" \
"MUL %B2, %A1 \n\t" \
"ADD %B0, R0 \n\t" \
"ADC %C0, R1 \n\t" \
"ADC %D0, R26 \n\t" \
"MUL %B1, %A2 \n\t" \
"ADD %B0, R0 \n\t" \
"ADC %C0, R1 \n\t" \
"ADC %D0, R26 \n\t" \
"CLR R1 \n\t" \
: \
"=&r" (longRes) \
: \
"a" (intIn1), \
"a" (intIn2) \
: \
"R26" \
) 

// intRes = intIn1~intIn2 >> 16
// g:
// R26 0i[p
// R27 32ޯČʂ޲1i[p
#define MultiU16X16toH16(intRes, intIn1, intIn2) \
asm volatile ( \
"CLR R26 \n\t" \
"MUL %A1, %A2 \n\t" \
"MOV R27, R1 \n\t" \
"MUL %B1, %B2 \n\t" \
"MOVW %A0, R0 \n\t" \
"MUL %B2, %A1 \n\t" \
"ADD R27, R0 \n\t" \
"ADC %A0, R1 \n\t" \
"ADC %B0, R26 \n\t" \
"MUL %B1, %A2 \n\t" \
"ADD R27, R0 \n\t" \
"ADC %A0, R1 \n\t" \
"ADC %B0, R26 \n\t" \
"CLR R1 \n\t" \
: \
"=&r" (intRes) \
: \
"a" (intIn1), \
"a" (intIn2) \
: \
"R26" , "R27" \
) 

// intRes = intIn1~intIn2 >> 16 + ۂ
// g:
// R26 0i[p
// R27 32ޯČʂ޲1i[p
// 21
#define MultiU16X16toH16Round(intRes, intIn1, intIn2) \
asm volatile ( \
"CLR R26 \n\t" \
"MUL %A1, %A2 \n\t" \
"MOV R27, R1 \n\t" \
"MUL %B1, %B2 \n\t" \
"MOVW %A0, R0 \n\t" \
"MUL %B2, %A1 \n\t" \
"ADD R27, R0 \n\t" \
"ADC %A0, R1 \n\t" \
"ADC %B0, R26 \n\t" \
"MUL %B1, %A2 \n\t" \
"ADD R27, R0 \n\t" \
"ADC %A0, R1 \n\t" \
"ADC %B0, R26 \n\t" \
"LSL R27 \n\t" \
"ADC %A0, R26 \n\t" \
"ADC %B0, R26 \n\t" \
"CLR R1 \n\t" \
: \
"=&r" (intRes) \
: \
"a" (intIn1), \
"a" (intIn2) \
: \
"R26" , "R27" \
) 


// t16~t16
// 22
#define MultiS16X16to32(longRes, intIn1, intIn2) \
asm volatile ( \
"CLR R26 \n\t" \
"MUL %A1, %A2 \n\t" \
"MOVW %A0, R0 \n\t" \
"MULS %B1, %B2 \n\t" \
"MOVW %C0, R0 \n\t" \
"MULSU %B2, %A1 \n\t" \
"SBC %D0, R26 \n\t" \
"ADD %B0, R0 \n\t" \
"ADC %C0, R1 \n\t" \
"ADC %D0, R26 \n\t" \
"MULSU %B1, %A2 \n\t" \
"SBC %D0, R26 \n\t" \
"ADD %B0, R0 \n\t" \
"ADC %C0, R1 \n\t" \
"ADC %D0, R26 \n\t" \
"CLR R1 \n\t" \
: \
"=&r" (longRes) \
: \
"a" (intIn1), \
"a" (intIn2) \
: \
"R26" \
)


// t16~t 16 >> 16
#define MultiS16X16toH16(intRes, intIn1, intIn2) \
asm volatile ( \
"CLR R26 \n\t" \
"MUL %A1, %A2 \n\t" \
"MOV R27, R1 \n\t" \
"MULS %B1, %B2 \n\t" \
"MOVW %A0, R0 \n\t" \
"MULSU %B2, %A1 \n\t" \
"SBC %B0, R26 \n\t" \
"ADD R27, R0 \n\t" \
"ADC %A0, R1 \n\t" \
"ADC %B0, R26 \n\t" \
"MULSU %B1, %A2 \n\t" \
"SBC %B0, R26 \n\t" \
"ADD R27, R0 \n\t" \
"ADC %A0, R1 \n\t" \
"ADC %B0, R26 \n\t" \
"CLR R1 \n\t" \
: \
"=&r" (intRes) \
: \
"a" (intIn1), \
"a" (intIn2) \
: \
"R26", "R27" \
)

// tƕȂ16ޯĐ32ޯČʂŏZ
#define MultiSU16X16to32(longRes, intIn1, intIn2) \
asm volatile ( \
"CLR R26 \n\t" \
"MUL %A1, %A2 \n\t" \
"MOVW %A0, R0 \n\t" \
"MULSU %B1, %B2 \n\t" \
"MOVW %C0, R0 \n\t" \
"MUL %B2, %A1 \n\t" \
"ADD %B0, R0 \n\t" \
"ADC %C0, R1 \n\t" \
"ADC %D0, R26 \n\t" \
"MULSU %B1, %A2 \n\t" \
"SBC %D0, R26 \n\t" \
"ADD %B0, R0 \n\t" \
"ADC %C0, R1 \n\t" \
"ADC %D0, R26 \n\t" \
"CLR R1 \n\t" \
: \
"=&r" (longRes) \
: \
"a" (intIn1), \
"a" (intIn2) \
: \
"R26" \
)

// tƕȂ̐ZČʂ̏16ޯĂԂ܂B
#define MultiSU16X16toH16(intRes, intIn1, intIn2) \
asm volatile ( \
"CLR R26 \n\t" \
"MUL %A1, %A2 \n\t" \
"MOV R27, R1 \n\t" \
"MULSU %B1, %B2 \n\t" \
"MOVW %A0, R0 \n\t" \
"MUL %B2, %A1 \n\t" \
"ADD R27, R0 \n\t" \
"ADC %A0, R1 \n\t" \
"ADC %B0, R26 \n\t" \
"MULSU %B1, %A2 \n\t" \
"SBC %B0, R26 \n\t" \
"ADD R27, R0 \n\t" \
"ADC %A0, R1 \n\t" \
"ADC %B0, R26 \n\t" \
"CLR R1 \n\t" \
: \
"=&r" (intRes) \
: \
"a" (intIn1), \
"a" (intIn2) \
: \
"R26", "R27" \
)

// tƕȂ̐Zĉ16ޯĂMSBɊÂČʂۂߏ16ޯĂԂ܂B
// 22
#define MultiSU16X16toH16Round(intRes, intIn1, intIn2) \
asm volatile ( \
"CLR R26 \n\t" \
"MUL %A1, %A2 \n\t" \
"MOV R27, R1 \n\t" \
"MULSU %B1, %B2 \n\t" \
"MOVW %A0, R0 \n\t" \
"MUL %A1, %B2 \n\t" \
"ADD R27, R0 \n\t" \
"ADC %A0, R1 \n\t" \
"ADC %B0, R26 \n\t" \
"MULSU %B1, %A2 \n\t" \
"SBC %B0, R26 \n\t" \
"ADD R27, R0 \n\t" \
"ADC %A0, R1 \n\t" \
"ADC %B0, R26 \n\t" \
"LSL R27 \n\t" \
"ADC %A0, R26 \n\t" \
"ADC %B0, R26 \n\t" \
"CLR R1 \n\t" \
: \
"=&r" (intRes) \
: \
"a" (intIn1), \
"a" (intIn2) \
: \
"R26", "R27" \
)

